{ Copyright (C) Chih-Cherng Chin  1999.       All rights reserved.    }
{                                                                     }
{ The author shall not be liable to the user for any direct, indirect }
{ or consequential loss arising from the use of, or inability to use, }
{ any unit, program or file howsoever caused. No warranty is given    }
{ that the units and programs will work under all circumstances.      }

unit assert_u;
interface
procedure assert(blAssertExpr : boolean);

implementation
const
   cHexChars : array [0..$F] of char = '0123456789ABCDEF';

procedure WriteHexWord(w : word);
begin
   write(cHexChars[Hi(w) shr 4], cHexChars[Hi(w) and $F],
      cHexChars[Lo(w) shr 4], cHexChars[Lo(w) and $F]);
end;

function wReturnOffset : word;
inline($8b/$46/$02);   { mov ax, [bp+2] }

function wReturnSegment : word;
inline($8b/$46/$04);   { mov ax, [bp+4] }

{$F+}
procedure assert(blAssertExpr : boolean);
{$F-}
begin
   if blAssertExpr = FALSE then begin
      write('Assertion failed before ');
      WriteHexWord(wReturnSegment-PrefixSeg-$10);
      write(':');
      WriteHexWord(wReturnOffset);
      writeln;
      halt(1);
   end;
end;

end.
